#!/bin/sh

rm -f all.h
rm -f all.cpp
rm -f getmapper.cpp

#============================
# make all.h
echo '/* this file is generated by makemisc */' > hoge.tmp
for f in *.h; do echo "#include \"$f\"" >> hoge.tmp; done
mv hoge.tmp all.h

#============================
# make all.cpp
echo '/* this file is generated by makemisc */' > hoge.tmp
for f in *.cpp; do echo "#include \"$f\"" >> hoge.tmp; done
mv hoge.tmp all.cpp


#============================
# make getmapper.cpp
cat > hoge.tmp <<EOS
/* this file is generated by makemisc */

NES_mapper*
GetMapper(NES* parent, NES_ROM* rom)
{
  switch(rom->get_mapper_num()) {
EOS

for line in $(cat all.cpp)
do
  id=$(expr $line : '"\(.*\)\.cpp"' | tr '[:lower:]' '[:upper:]')
  if [ $id ]; then 
    num=$(expr $id : '0*\(.*\)')
    if [ ! $num ]; then num="0"; fi
    casenum=$num
    if [ $casenum = "NSF" ]; then casenum="12"; fi
    cat >> hoge.tmp <<EOS
  case $casenum:
    return new NES_mapper$num(parent);

EOS
  fi
done

cat >> hoge.tmp <<EOS
  default:
    return NULL;  // mapper not supported
  }
}
EOS
mv hoge.tmp getmapper.cpp

